From efb7c86ce7488222e4ea1a1111aa310351dce7d6 Mon Sep 17 00:00:00 2001
From: Julius Plenz <plenz@cis.fu-berlin.de>
Date: Mon, 24 Oct 2011 16:32:39 +0200
Subject: [PATCH 03/19] applying debian/patches/mutt-patched/sidebar-dotted

Signed-off-by: Julius Plenz <plenz@cis.fu-berlin.de>
---
 init.h    |    5 +++++
 mutt.h    |    1 +
 sidebar.c |   15 ++++++++++++---
 3 files changed, 18 insertions(+), 3 deletions(-)

diff --git a/init.h b/init.h
index c3fe397..4671984 100644
--- a/init.h
+++ b/init.h
@@ -1969,6 +1969,11 @@ struct option_t MuttVars[] = {
   ** .pp
   ** The width of the sidebar.
   */
+  { "sidebar_shortpath", DT_BOOL, R_BOTH, OPTSIDEBARSHORTPATH, 0 },
+  /*
+  ** .pp
+  ** Should the sidebar shorten the path showed.
+  */
   { "pgp_use_gpg_agent", DT_BOOL, R_NONE, OPTUSEGPGAGENT, 0},
   /*
   ** .pp
diff --git a/mutt.h b/mutt.h
index 25822e5..b9bf895 100644
--- a/mutt.h
+++ b/mutt.h
@@ -420,6 +420,7 @@ enum
   OPTSAVENAME,
   OPTSCORE,
   OPTSIDEBAR,
+  OPTSIDEBARSHORTPATH,
   OPTSIGDASHES,
   OPTSIGONTOP,
   OPTSORTRE,
diff --git a/sidebar.c b/sidebar.c
index f9413be..94127bb 100644
--- a/sidebar.c
+++ b/sidebar.c
@@ -258,14 +258,23 @@ int draw_sidebar(int menu) {
 			int i;
 			tmp_folder_name = tmp->path + strlen(Maildir);
 			for (i = 0; i < strlen(tmp->path) - strlen(Maildir); i++) {
-				if (tmp_folder_name[i] == '/') sidebar_folder_depth++;
+ 				if (tmp_folder_name[i] == '/'  || tmp_folder_name[i] == '.') sidebar_folder_depth++;
 			}   
 			if (sidebar_folder_depth > 0) {
-				sidebar_folder_name = malloc(strlen(basename(tmp->path)) + sidebar_folder_depth + 1);
+ 				if (option(OPTSIDEBARSHORTPATH)) {
+ 					tmp_folder_name = strrchr(tmp->path, '.');
+ 					if (tmp_folder_name == NULL)
+ 						tmp_folder_name = tmp->path;
+ 					else
+						tmp_folder_name++;
+ 				}
+ 				else
+ 					tmp_folder_name = tmp->path;
+ 				sidebar_folder_name = malloc(strlen(basename(tmp_folder_name)) + sidebar_folder_depth + 1);
 				for (i=0; i < sidebar_folder_depth; i++)
 					sidebar_folder_name[i]=' ';
 				sidebar_folder_name[i]=0;
-				strncat(sidebar_folder_name, basename(tmp->path), strlen(basename(tmp->path)) + sidebar_folder_depth);
+ 				strncat(sidebar_folder_name, basename(tmp_folder_name), strlen(basename(tmp_folder_name)) + sidebar_folder_depth);
 			}
 		}
 		printw( "%.*s", SidebarWidth - delim_len + 1,
-- 
1.7.7.3

